(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var babelHelpers = Package['babel-runtime'].babelHelpers;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPowerboxRequest;

(function(){

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                           //
// packages/sandstorm-ui-powerbox/powerbox-server.js                                                         //
//                                                                                                           //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                             //
Meteor.methods({                                                                                             // 1
  newFrontendRef: function (sessionId, frontendRefVariety) {                                                 // 2
    // Checks if the requester is an admin, and if so, provides a new frontendref of the desired             //
    // variety, provided by the requesting user, owned by the grain for this session.                        //
    check(sessionId, String);                                                                                // 5
    check(frontendRefVariety, Match.OneOf({ ipNetwork: Boolean }, { ipInterface: Boolean }));                // 6
                                                                                                             //
    var db = this.connection.sandstormDb;                                                                    // 11
    if (!db.isAdmin(this.userId)) {                                                                          // 12
      throw new Meteor.Error(403, "User must be an admin to powerbox offer frontendrefs");                   // 13
    }                                                                                                        //
                                                                                                             //
    var session = db.collections.sessions.findOne(sessionId);                                                // 16
    if (!session) {                                                                                          // 17
      throw new Meteor.Error(403, "Invalid session ID");                                                     // 18
    }                                                                                                        //
                                                                                                             //
    var grainId = session.grainId;                                                                           // 21
    var apiTokenOwner = {                                                                                    // 22
      grain: {                                                                                               // 23
        grainId: grainId,                                                                                    // 24
        saveLabel: { defaultText: "Admin-provided raw outgoing network access" },                            // 25
        introducerIdentity: session.identityId                                                               // 26
      }                                                                                                      //
    };                                                                                                       //
                                                                                                             //
    var requirements = [{ userIsAdmin: Meteor.userId() }];                                                   // 30
                                                                                                             //
    // TODO: refactor: reaches out into core.js                                                              //
    var sturdyRef = waitPromise(saveFrontendRef(frontendRefVariety, apiTokenOwner, requirements)).sturdyRef;
    return sturdyRef.toString();                                                                             // 36
  }                                                                                                          //
});                                                                                                          //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sandstorm-ui-powerbox'] = {
  SandstormPowerboxRequest: SandstormPowerboxRequest
};

})();

//# sourceMappingURL=sandstorm-ui-powerbox.js.map
